<?php 

require_once dirname(__DIR__).'/../sdk/WoocommerceFacturanteParser/WoocommerceStates.php';
class Dni{

 
	/**
	* Adds DNI to register form
	*
	*/
	public static function woo_facturante_add_dni_field_to_register(){
			
		?>
		<p class="form-row form-row-first">
			<label for="woo_facturante_billing_dni"><?php _e( 'DNI', 'woo-facturante' ); ?> <span class="required">*</span></label>
			<input type="text" class="input-text" name="billing_dni_facturante" id="reg_billing_dni_facturante" value="<?php if ( ! empty( $_POST['billing_dni_facturante'] ) ) esc_attr_e( $_POST['billing_dni_facturante'] ); ?>" />
		</p>
		<?php

}

/**
* Validates DNI in register form
*
*/
public static function woo_facturante_validate_extra_register_fields( $errors ){
	
	if ( isset( $_POST['billing_dni_facturante'] ) && empty( $_POST['billing_dni_facturante'] ) ) {
		
		if ( !preg_match('/^[0-9]*$/', $_POST['billing_dni_facturante']) ){
			
			$errors->add( 'billing_dni_facturante_error', __( '<strong>Error</strong>: DNI must be a numeric value!.', 'woo-facturante' ) );
			
		}
		$_POST['type_document_facturante'] = 1;
		$_POST['billing_dni_facturante'] = '1';
	}
	
	return $errors;
	
}


/**
* Adds DNI to my account form
*
*/
public static function woo_facturante_add_dni_field_to_my_account(){
		
		$user_id = get_current_user_id();
		
		$user = get_userdata( $user_id );

		if ( !$user )
			return;
		
		?>
		  <p class="woocommerce-FormRow woocommerce-FormRow--wide form-row form-row-wide"> 
			  <label for="woo_facturante_billing_dni"><?php _e( 'DNI', 'woo-facturante' ); ?> <span class="required">*</span></label> 
			  <input type="text" class="woocommerce-Input woocommerce-Input--text input-text" name="billing_dni_facturante" id="ma_billing_dni_facturante" value="<?php echo esc_attr( $user->billing_dni_facturante ); ?>" /> 
		  </p> 
		<?php
}

/**
* Saves DNI in my account and register page
*
*
*/
public function woo_facturante_save_DNI( $user_id ) {
	
	if(isset($_POST[ 'billing_dni_facturante' ])){
		
		update_user_meta( $user_id, 'billing_dni_facturante', sanitize_text_field( $_POST[ 'billing_dni_facturante' ] ) ); 
		update_user_meta( $user_id, 'type_document_facturante', sanitize_text_field( $_POST[ 'type_document_facturante' ] ) ); 
	
	}

}

/**
* Add DNI field to checkout form
*
*/
public static function woo_facturante_dni_checkout_field( $checkout_fields ){
	
	 $user_meta  =  get_user_meta ( get_current_user_id() );
	 
	 $billing_dni =  $user_meta['billing_dni_facturante']['0'];
	
	 $checkout_fields['billing']['type_document_facturante']  =  array(
		'label'          => __('Tipo de documento', 'woocommerce'),
		'placeholder'    => _x('coloque su tipo de documento', 'placeholder', 'woo-facturante'),
		'required'       => true,
		'clear'          => false,
		'type'           => 'select',
		'class'          => array('form-row-wide'),
		'options' => array(
			'1' => 'DNI',
			'6' => 'CUIT'
	   )
	);

	 $checkout_fields['billing']['billing_dni_facturante']  =  array(
		'label'          => __('Documento o Cuit (sin guiones)', 'woocommerce'),
		'placeholder'    => _x('enter your dni', 'placeholder', 'woo-facturante'),
		'required'       => true,
		'clear'          => false,
		'type'           => 'text',
		'class'          => array('form-row-wide'),
	);

	 return $checkout_fields;
	
}


	
	/**
	* Validates DNI field in checkout proccess
	*
	*/
	public static function woo_facturante_checkout_field_process() {
		
		if($_POST['type_document_facturante'] == 1){
			if(!$_POST['billing_dni_facturante']){
				wc_add_notice( __( 'El DNI no puede estar vacio.','woo-facturante' ), 'error' );
			}
			if (!preg_match('/^[0-9]*$/', $_POST['billing_dni_facturante']) || strlen($_POST['billing_dni_facturante']) > 8 ){
				wc_add_notice( __( 'Su DNI es invalido.','woo-facturante' ), 'error' );
			}
		}else{
			if(!$_POST['billing_dni_facturante']){
				wc_add_notice( __( 'El CUIT no puede estar vacio.','woo-facturante' ), 'error' );
			}
			if ( self::validar_CUIT($_POST['billing_dni_facturante']) == false || !preg_match('/^[0-9]*$/', $_POST['billing_dni_facturante']) || strlen($_POST['billing_dni_facturante']) != 11 ){
				wc_add_notice( __( 'Su CUIT es invalido.','woo-facturante' ), 'error' );
			}
		}	

	}

	
 private static function validar_CUIT($cuit){
            $cadena = str_split($cuit);

            $result = $cadena[0]*5;
            $result += $cadena[1]*4;
            $result += $cadena[2]*3;
            $result += $cadena[3]*2;
            $result += $cadena[4]*7;
            $result += $cadena[5]*6;
            $result += $cadena[6]*5;
            $result += $cadena[7]*4;
            $result += $cadena[8]*3;
            $result += $cadena[9]*2;

            $div = intval($result/11);
            $resto = $result - ($div*11);

            if($resto==0){
                if($resto==$cadena[10]){
                    return true;
                }else{
                    return false;
                }
            }elseif($resto==1){
                if($cadena[10]==9 AND $cadena[0]==2 AND $cadena[1]==3){
                    return true;
                }elseif($cadena[10]==4 AND $cadena[0]==2 AND $cadena[1]==3){
                    return true;
                }
            }elseif($cadena[10]==(11-$resto)){
                return true;
            }else{
                return false;
            }
		}
		
	/**
	* Saves user DNI field to order
	*
	*/
	public static function woo_facturante_update_order_meta( $order_id ) {
		
		if ( ! empty( $_POST['billing_dni_facturante'] ) ) {	
			update_post_meta( $order_id, 'DNI', sanitize_text_field( $_POST['billing_dni_facturante'] ) );
			update_post_meta( $order_id, 'type_document_facturante', sanitize_text_field( $_POST['type_document_facturante'] ) );		
		}
	
	}
	
	/*
	* Shows customer DNI in order page
	*
	*/
	public static function woo_facturante_display_admin_order_meta($order){

		$estado_facturante = get_post_meta($order->id, '_estado_facturante', true );
		$inErrorState = WoocommerceStates::isEditableDocumentState($estado_facturante);
		
		if($inErrorState){
			$select_field = array (
				'id' => 'my_select' ,
				'name' => __( 'type_document_facturante', 'woo-facturante' ),
				'label' => __ ( 'Tipo de documento' , 'Indica el tipo de documento para facturar' ),
				'type' => 'select',
				'desc' => __( 'Tipo de documento', 'woo-facturante' ),
				'id'   => 'wc_settings_tab_woo_facturante_tipo_de_documento',
				'value' => get_post_meta( 
					$order->id, 
					'type_document_facturante', 
					true ),
				'options' => array(
					'1' => 'DNI',
					'6' => 'CUIT'
				)
			);
		
			echo"<div class='address'>
			";
			if(get_post_meta( $order->id,'errors_order_documents',true ) == "YES"){
				update_post_meta($order->id, 'errors_order_documents', "NO" );
				echo "<strong style='color:#F08080;'>El DNI/CUIT era incorrecto, solo se actualizara si es correcto</strong>";
			}
			echo"	<div class='edit_address'>
					
					".woocommerce_wp_select($select_field)."
					".woocommerce_wp_text_input( array('value'=>get_post_meta( 
						$order->id, 
						'DNI', 
						true ), 
					'id' => '_cloudways_dropdown', 
					'label' => __( 'Documento: ' ), 
					'name' => __( 'DNI', 'woo-facturante' ),
					'wrapper_class' => '_billing_company_field' ) )."
				</div>
			</div>";
		}else{
			//var_dump('hola');die();
			$optionsDniOrCuit = array (	'1' => 'DNI','6' => 'CUIT'); 
			$typeDocumentName =   $optionsDniOrCuit[get_post_meta($order->id, 'type_document_facturante', true )];
			$dniOrCuit = get_post_meta($order->id, 'DNI', true );

			echo '<div class="address">
						<p class=" form-field wc_settings_tab_woo_facturante_tipo_de_documento_field">
							<label for="wc_settings_tab_woo_facturante_tipo_de_documento">Tipo de documento</label>
							'.$typeDocumentName.'
						</p>
						<p class="form-field _cloudways_dropdown_field _billing_company_field">
							<label for="_cloudways_dropdown">Documento: </label>
							'.$dniOrCuit.'
						</p>
					</div>';

		}
	}

	public function save_facturante_doc_and_type(){
		//wc_add_notice( __( 'Su DNI/CUIT es invalido.','woo-facturante' ), 'error' );
		
		$order_id = sanitize_text_field($_POST['post_ID']);
		$estado_facturante = get_post_meta($order_id , '_estado_facturante', true );
		$inErrorState = WoocommerceStates::isEditableDocumentState($estado_facturante);

		if($inErrorState){
			$type_document_facturante = sanitize_text_field($_POST['type_document_facturante']);
			$document = sanitize_text_field($_POST['DNI']);
		
			if($type_document_facturante == "1"){
				if (preg_match('/^[0-9]*$/', $document ) && strlen($document ) < 10 ){
					update_post_meta( $order_id, 'DNI',  $document   );
					update_post_meta( $order_id, 'type_document_facturante', $type_document_facturante );
					update_post_meta( $order_id, 'errors_order_documents', "NO" );
				}else{
					update_post_meta( $order_id, 'errors_order_documents', "YES" );
				}
			}else{
				if ( self::validar_CUIT($document)){
					update_post_meta( $order_id, 'DNI', $document   );
					update_post_meta( $order_id, 'type_document_facturante',  $type_document_facturante );
					update_post_meta( $order_id, 'errors_order_documents', "NO" );
				}else{
					update_post_meta( $order_id, 'errors_order_documents', "YES" );
				}
			}
		}
	
	}
	

	/*
	* Shows customer DNI in email
	*
	*
	*/
	
	public static function woo_facturante_display_dni_in_email_fields( $keys ){		
		 
        $keys['DNI'] = 'DNI';
        
        return $keys;
		
	}

}