<?php
require_once dirname(__DIR__). '/../sdk/WoocommerceFacturanteParser/WoocommerceFacturanteParser.php';
require_once dirname(__DIR__). '/../sdk/WoocommerceFacturanteParser/WoocommerceFacturanteStatesMapper/WoocommerceFacturanteStatesMapper.php';
require_once dirname(__DIR__).'/../sdk/WoocommerceFacturanteParser/WoocommerceStates.php';
require_once dirname(__DIR__). '/../sdk/FacturanteSDK.php';
require_once dirname(__FILE__). '/Order.php';




class Invoice{
    	
	/**
	* Process invoice request
	*
	**/

	function callAPI($method, $url, $data){
		$curl = curl_init();
		switch ($method){
		   case "POST":
			  curl_setopt($curl, CURLOPT_POST, 1);
			  if ($data)
				 curl_setopt($curl, CURLOPT_POSTFIELDS, $data);
			  break;
		}
		// OPTIONS:
		curl_setopt($curl, CURLOPT_URL, $url);
		
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($curl, CURLOPT_HTTPAUTH, CURLAUTH_BASIC);
		// EXECUTE:
		$result = curl_exec($curl);
		if(!$result){die("Connection Failure");}
		curl_close($curl);
		return $result;
	 }
	
	public function woo_facturante_invoice($order_in = null){	
				
		if($order_in == null){
			$order_id = intval($_POST["order"]);
		}else{
			$order_id = $order_in;
		}
		$order = wc_get_order( $order_id );

		/*$url = 'https://webhook.site/bdd8d420-ed53-45f5-a146-d6d0755aab2a';
		//create a new cURL resource
		$ch = curl_init($url);
		//setup request to send json via POST
		$data = array(
			'total'=> $order->get_total(),
			'total_discount'=> $order->get_total_discount(),
			'fees'=> $order->get_fees(),
			'refunded'=> $order->get_total_refunded(),
			'other_discount'=> $order->get_discount_total(),
			'other3_discount'=> $order->get_discount_to_display(),
			'subtotal'=> $order-> get_subtotal(),
			'total_fees'=> $order-> get_total_fees(),
			'shipment'=> $order-> get_shipping_total(),
			'payment_method'=> $order->get_payment_method(),
			'payment_method_title'=> $order->get_payment_method_title()
		);
		$payload = json_encode(array("user" => $data));
		//attach encoded JSON string to the POST fields
		curl_setopt($ch, CURLOPT_POSTFIELDS, $payload);
		//set the content type to application/json
		curl_setopt($ch, CURLOPT_HTTPHEADER, array('Content-Type:application/json'));
		//return response instead of outputting
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
		//execute the POST request
		$result = curl_exec($ch);
		//close cURL resource
		curl_close($ch);
		//Obtain and prepare order data				*/
		
		$order_meta = get_post_meta($order_id);
		$dni = get_post_meta($order_id,'DNI',true);
		$prefix = get_option('wc_settings_tab_woo_facturante_prefix');

		if(!isset($dni) || $dni==null)
			$dni=1;
		
		//Response
		try {
			$woocommerceFacturanteParser = new WoocommerceFacturanteParser($order,$order_meta);								

			$paymentCondition = $order->get_payment_method();
			$paymentConditionId = 4;
			switch(strtolower($paymentCondition))
			{
				case "mobbex":
					$paymentConditionId=20;
					break;
				case "mercadopago":
					$paymentConditionId=8;
					break;
				case "bacs":
					$paymentConditionId=21;
					break;
				default:
					$paymentConditionId=4;
					break;
			}


			$client = $woocommerceFacturanteParser->parseClient($dni,true,$paymentConditionId);			
			$header = $woocommerceFacturanteParser->parseHeader($prefix,$paymentConditionId);						
			$items = $woocommerceFacturanteParser->parseItems();	

			$auth = array(	
				"Empresa" => get_option( 'wc_settings_tab_woo_facturante_organization_ID' ),
				"Hash" => get_option( 'wc_settings_tab_woo_facturante_hash' ),
				"Usuario" => get_option( 'wc_settings_tab_woo_facturante_user')
			);

			$fsdk = new FacturanteSDK($auth);			
			$response = $fsdk->generateFullReceipt($client,$header,$items);	
			
			if (isset($response['data']['IdComprobante']) ) {
				update_post_meta( $order_id, '_invoice_id', $response['data']['IdComprobante'] );
				update_post_meta( $order_id, '_estado_facturante', WoocommerceStates::PROCESANDO );
				$now = new DateTime();
				update_post_meta( $order_id, '_timestamp_procesando_facturante', $now->getTimestamp());
			}else{
				update_post_meta( $order_id, '_estado_facturante', WoocommerceStates::ERROR_COMPROBANTE );
			}

			if ( $response['error'] === true ) {
				update_post_meta( $order_id, '_error_facturante', $response['data'] );
			}

			if($order_in == null){ 
				echo json_encode($response);
				exit;
			}	
		} catch (Exception $e)  {		  
			update_post_meta( $order_id, '_error_facturante', $e->getMessage());
			if($order_in == null){  
				echo json_encode($e->getMessage());		
			}
			//var_dump($client->__getLastRequest());			  
			//var_dump($client->__getLastResponse());		
		}

		
	}
	
	public function woo_facturante_view_invoice(){
		
		$order_id = intval($_POST["order"]);
		$invoice_id = get_post_meta($order_id,'_invoice_id',true);
		$auth = array(	
			"Empresa" => get_option( 'wc_settings_tab_woo_facturante_organization_ID' ),
			"Hash" => get_option( 'wc_settings_tab_woo_facturante_hash' ),
			"Usuario" => get_option( 'wc_settings_tab_woo_facturante_user')
		);
		//sdk stuff
		$fsdk = new FacturanteSDK($auth);
		$data = ['id_comprobante'=> $invoice_id];
		try {
		  
			$response = $fsdk->viewInvoice($data);
			//map facturante state to wordpress state
			if(isset($response['data']['EstadoComprobante'])){
			  $WoocommerceFacturanteStatesMapper = new WoocommerceFacturanteStatesMapper();
			  $wpState = $WoocommerceFacturanteStatesMapper->map($response['data']['EstadoComprobante']);
			  update_post_meta( $order_id, '_estado_facturante', $wpState );
			  $response['data']['EstadoComprobante'] = $wpState;
			  //check for error of afip
			  if ( $response['error'] === true ) {
				update_post_meta( $order_id, '_error_facturante', $response['data']['MensajeAfip'] );
			  }
			  echo json_encode($response);	  
			  exit;
			}
		
		} catch (Exception $e)  {
			  echo json_encode($e->getMessage());		
		}

	
	}
	
	public function woo_facturante_test_automatic($wccm_before_checkout){
		global $post;
		$newData = $wccm_before_checkout->get_data()['type_document_facturante'];
		$order_id = $wccm_before_checkout->get_id();
		$is_active_automatic = get_option('facturante_automatic');
		$status_automatic = get_option('facturante_automatic_invoice_state');
		$invoice_id = get_post_meta($order_id,'_invoice_id',true);
		$status_now = $wccm_before_checkout->get_data()['status'];
		if($this->compareStatus($status_now,$status_automatic) && $is_active_automatic == "yes" && empty($invoice_id)){
			$this->woo_facturante_invoice($order_id);
		}
	}

	public function compareStatus($status_now, $status_automatic){
		if($status_now == $status_automatic || "wc-".$status_now == $status_automatic){
			return true;
		}
		return false;
	}

}