<?php
require_once dirname(__DIR__).'/../sdk/WoocommerceFacturanteParser/WoocommerceStates.php';

class Order{
	public function facturante_buttons_column($columns){
        $hola = "10";
		foreach ( $columns as $column_name => $column_info ) {

			$new_columns[ $column_name ] = $column_info;
	
			if ( 'order_total' === $column_name ) {
				$new_columns['order_buttons_facturante'] = __( 'Facturante', 'my-textdomain' );
			}
		}
     return $new_columns;
	}

	function sv_helper_get_order_meta( $order, $key = '', $single = true, $context = 'edit' ) {

        if ( defined( 'WC_VERSION' ) && WC_VERSION && version_compare( WC_VERSION, '3.0', '>=' ) ) {
            $value = $order->get_meta( $key, $single, $context );
        } else {
         $order_id = is_callable( array( $order, 'get_id' ) ) ? $order->get_id() : $order->id;
            $value    = get_post_meta( $order_id, $key, $single );
        }

        return $value;
	}
	
	function facturante_content_column( $column ) {
		global $post;
		$invoice_id = get_post_meta($post->ID,'_invoice_id',true);	
		$the_order = new WC_Order($post->ID);
		$estado_facturante = get_post_meta( $post->ID, '_estado_facturante', true );
		$error_facturante = get_post_meta( $post->ID, '_error_facturante', true );
		$encoded_error = json_encode($error_facturante);
	

		if ( 'order_buttons_facturante' === $column ) {
			$invoice_id = get_post_meta($post->ID,'_invoice_id',true);	
			$the_order = new WC_Order($post->ID);
			$estado_facturante = get_post_meta( $post->ID, '_estado_facturante', true );

		//	$elementId = "refreshFactura".$post->ID;
		//	echo("<div class='loader'>Loading...</div>");

			if ( ! $the_order->has_status( array( 'cancelled' ) ) && ( $the_order->has_status( array( 'processing' ) ) || $the_order->has_status( array( 'completed' ) ) ) ){ 

				//ACCIONES FACTURACION
            	if($estado_facturante == WoocommerceStates::PROCESANDO){
					//echo("<div class='order_buttons_div'>");
					echo("<div>");
					$elementId = "refreshFactura".$post->ID;
                    echo("<a class='button' href='javascript:void(0)' id=$elementId onClick='refresh($post->ID,this)'><i class='fas fa-sync-alt'  title='Actualizar'></i> Actualizar</a>");
					
				}elseif($estado_facturante == WoocommerceStates::OK){	
					echo("<div>");
					$pdf = get_post_meta( $post->ID, '_pdf_facturante', true );
					if(isset($pdf) && $pdf!=""){
						echo("<a class='button' href='".$pdf."' target='_blank'><i class='fas fa-file-pdf'></i> Descargar Factura</a>");
					}
					else{
						//sdk stuff
						$auth = array(	
							"Empresa" => get_option( 'wc_settings_tab_woo_facturante_organization_ID' ),
							"Hash" => get_option( 'wc_settings_tab_woo_facturante_hash' ),
							"Usuario" => get_option( 'wc_settings_tab_woo_facturante_user')
						);
						$fsdk = new FacturanteSDK($auth);
						$data = ['id_comprobante'=> $invoice_id];
						$response = $fsdk->viewInvoice($data);
						$url = (isset($response['data']['URLPDF']))?$response['data']['URLPDF']:'javascript:void(0);';
						echo("<a class='button' href='".$url."' target='_blank'><i class='fas fa-file-pdf'></i> Descargar Factura</a>");
					}
				}elseif($estado_facturante == WoocommerceStates::ERROR_COMPROBANTE){
					echo("<div class='order_buttons_div'>")	;
					$elementId = "reprocesarFactura".$post->ID;
					echo("<a class='button' href='javascript:void(0)' id=$elementId onClick='generateInvoice($post->ID,this)'>
						<i class='fas fa-file-invoice'  title='Descargar Factura'  title='Reprocesar'></i> Reprocesar</a>");
					
				} elseif($estado_facturante == WoocommerceStates::ERROR_AFIP){
					echo("<div class='order_buttons_div'>");
					$elementId = "refreshFacturaError".$post->ID;
					echo("<a class='button' href='javascript:void(0)' id=$elementId onClick='refresh($post->ID,this)'><i class='fas fa-sync-alt'  title='Reprocesar'></i> Reprocesar</a>'>					 
						 </a>");
				}else{
					echo("<div>");
					$elementId = "generarFactura".$post->ID;
					echo("<a class='button' href='javascript:void(0)' id=$elementId  onClick='generateInvoice($post->ID,this)'  data-toggle='fac-modal'>
						<i class='fas fa-file-invoice'  title='Generar Factura'></i> Generar Factura</a>");
				}
			}else{
				if($estado_facturante == WoocommerceStates::OK){	
					echo("<div>");
					$pdf = get_post_meta( $post->ID, '_pdf_facturante', true );
					if(isset($pdf) && $pdf!=""){
						echo("<a class='button' href='".$pdf."' target='_blank'><i class='fas fa-file-pdf'></i> Descargar Factura</a>");
					}
					else{
						//sdk stuff
						$auth = array(	
							"Empresa" => get_option( 'wc_settings_tab_woo_facturante_organization_ID' ),
							"Hash" => get_option( 'wc_settings_tab_woo_facturante_hash' ),
							"Usuario" => get_option( 'wc_settings_tab_woo_facturante_user')
						);
						$fsdk = new FacturanteSDK($auth);
						$data = ['id_comprobante'=> $invoice_id];
						$response = $fsdk->viewInvoice($data);
						$url = (isset($response['data']['URLPDF']))?$response['data']['URLPDF']:'javascript:void(0);';
						echo("<a class='button' href='".$url."' target='_blank'><i class='fas fa-file-pdf'></i> Descargar Factura</a>");
					}
				}
				else{
					echo("No es posible generar la factura en este estado");
				}
			}
			//END ACCIONES FACTURACION

			//ERRORES
			if($estado_facturante!='' && $estado_facturante != WoocommerceStates::OK){
				if($estado_facturante == WoocommerceStates::PROCESANDO || $estado_facturante == WoocommerceStates::ERROR_AFIP ) {
					$title = '';
					$timestamp_procesando_facturante = get_post_meta( $post->ID, '_timestamp_procesando_facturante', true) ;
					if($timestamp_procesando_facturante){
						$now = new DateTime();
						$diff =( $now->getTimestamp() - $timestamp_procesando_facturante) /(60*60*24);
						$stateName=($estado_facturante == WoocommerceStates::PROCESANDO)?'pendiente':'error de afip';
						if($diff >= 1){
							$encoded_error = json_encode("Por favor recargue  el comprobante, si sigue en estado $stateName, por favor comuniquese con el equipo de soporte a soporte@facturante.com");
							echo(" <a class='button' href='javascript:void(0)' onClick='addModalContent($encoded_error)'  data-toggle='fac-modal' data-target='#error'><i class='fas fa-info-circle'></i> Ver detalle</a>");
						}
					}
				}else{
					echo(" <a class='button' href='javascript:void(0)' onClick='addModalContent($encoded_error)'  data-toggle='fac-modal' data-target='#error'><i class='fas fa-info-circle'></i> Ver detalle</a>");
				}
			}
			//END ERRORES
			if(!empty($invoice_id))
			$this->facturante_content_column_nc( $column );
			echo("</div>");
		}
	}

	function facturante_content_column_nc( $column ) {
		global $post;
		$invoice_id = get_post_meta($post->ID,'_nc_id',true);	
		$the_order = new WC_Order($post->ID);
		$estado_facturante = get_post_meta( $post->ID, '_estado_facturante_nc', true );
		$error_facturante = get_post_meta( $post->ID, '_error_facturante_nc', true );
		$encoded_error = json_encode($error_facturante);
	


			//ACCIONES FACTURACION
			if($estado_facturante == WoocommerceStates::PROCESANDO){
				//echo("<div class='order_buttons_div'>");
				echo("<div>");
				$elementId = "refreshFactura".$post->ID;
				echo("<a class='button' href='javascript:void(0)' id=$elementId onClick='refresh($post->ID,this,true)'><i class='fas fa-sync-alt'  title='Actualizar'></i> Actualizar</a>");
				
			}elseif($estado_facturante == WoocommerceStates::OK){	
				echo("<div>");

				$pdf = get_post_meta( $post->ID, '_pdf_facturante', true );
				if(isset($pdf) && $pdf!=""){
					echo("<a class='button' href='".$pdf."' target='_blank'><i class='fas fa-file-pdf'></i> Descargar Nota de Crédito</a>");
				}
				else{
					//sdk stuff
					$auth = array(	
						"Empresa" => get_option( 'wc_settings_tab_woo_facturante_organization_ID' ),
						"Hash" => get_option( 'wc_settings_tab_woo_facturante_hash' ),
						"Usuario" => get_option( 'wc_settings_tab_woo_facturante_user')
					);
					$fsdk = new FacturanteSDK($auth);
					$data = ['id_comprobante'=> $invoice_id];
					$response = $fsdk->viewInvoice($data);
					$url = (isset($response['data']['URLPDF']))?$response['data']['URLPDF']:'javascript:void(0);';
					echo("<a class='button' href='".$url."' target='_blank'><i class='fas fa-file-pdf'></i> Descargar Nota de Credito</a>");
				}
			}elseif($estado_facturante == WoocommerceStates::ERROR_COMPROBANTE){
				echo("<div class='order_buttons_div'>");
				$elementId = "reprocesarFactura".$post->ID;
				echo("<a class='button' href='javascript:void(0)' id=$elementId onClick='generateCreditNote($post->ID,this)'>
					<i class='fas fa-file-invoice'    title='Reprocesar'></i> Reprocesar</a>");
				
			} elseif($estado_facturante == WoocommerceStates::ERROR_AFIP){
				echo("<div class='order_buttons_div'>");
				$elementId = "refreshFacturaError".$post->ID;
				echo("<a class='button' href='javascript:void(0)' id=$elementId onClick='refresh($post->ID,this, true)'><i class='fas fa-sync-alt'  title='Reprocesar'></i> Reprocesar</a>'>					 
						</a>");
			}else{
				echo("<div>");
				$elementId = "generarFactura".$post->ID;
				echo("<a class='button' href='javascript:void(0)' id=$elementId  onClick='generateCreditNote($post->ID,this)'  data-toggle='fac-modal'>
					<i class='fas fa-file-invoice'  title='Generar Nota de Credito'></i> Generar Nota de Credito</a>");
			}
		//END ACCIONES FACTURACION

		//ERRORES
		if($estado_facturante!='' && $estado_facturante != WoocommerceStates::OK){
			if($estado_facturante == WoocommerceStates::PROCESANDO || $estado_facturante == WoocommerceStates::ERROR_AFIP ) {
				$title = '';
				$timestamp_procesando_facturante = get_post_meta( $post->ID, '_timestamp_procesando_facturante_nc', true) ;
				if($timestamp_procesando_facturante){
					$now = new DateTime();
					$diff =( $now->getTimestamp() - $timestamp_procesando_facturante) /(60*60*24);
					$stateName=($estado_facturante == WoocommerceStates::PROCESANDO)?'pendiente':'error de afip';
					if($diff >= 1){
						$encoded_error = json_encode("Por favor recargue  el comprobante, si sigue en estado $stateName, por favor comuniquese con el equipo de soporte a soporte@facturante.com");
						echo(" <a class='button' href='javascript:void(0)' onClick='addModalContent($encoded_error)'  data-toggle='fac-modal' data-target='#error'><i class='fas fa-info-circle'></i> Ver detalle</a>");
					}
				}
			}else{
				echo(" <a class='button' href='javascript:void(0)' onClick='addModalContent($encoded_error)'  data-toggle='fac-modal' data-target='#error'><i class='fas fa-info-circle'></i> Ver detalle</a>");
			}
		}
	}
}