<?php
//namespace Admin/Classes;

class Settings{	
    
	public function __construct( $plugin_name="def", $version=1 ) {

		//$this->plugin_name = $plugin_name;
		//$this->version = $version;
		//$this->soap_url = 'http://testing.facturante.com/api/Comprobantes.svc?wsdl';
		
	}

    public function add_settings_tab( $settings_tabs ) {
        
		$settings_tabs['settings_tab_woo_facturante'] = __( 'Configuración Facturante', 'woo-facturante' );
        
		return $settings_tabs;
    
	}
	
	 /**
     * Uses the WooCommerce admin fields API to output settings via the @see woocommerce_admin_fields() function.
     *
     * @uses woocommerce_admin_fields()
     * @uses self::get_settings()
     */	 
    public static function settings_tab() {
       
	   woocommerce_admin_fields( self::get_settings() );
    
	}


    /**
     * Uses the WooCommerce options API to save settings via the @see woocommerce_update_options() function.
     *
     * @uses woocommerce_update_options()
     * @uses self::get_settings()
     */ 
    public static function update_settings() {
        
		woocommerce_update_options( self::get_settings() );
    
    }
    
    	
    /**
     * Get all the settings for this plugin for @see woocommerce_admin_fields() function.
     *
     * @return array Array of settings for @see woocommerce_admin_fields() function.
     */
    public static function get_settings() {
        $allStatus = wc_get_order_statuses();
        
        $settings = array(
            'section_title' => array(
                'name'     => __( 'Configuración de Facturante para WooCommerce', 'woo-facturante' ),
                'type'     => 'title',
                'desc'     => 'Ingresá los siguientes datos para sincronizar tu tienda con Facturante y definí tus preferencias de facturación. <a href="https://facturante.ladesk.com/324892-Facturante---WooCommerce-C%C3%B3mo-instalar-el-plugin-de-Facturaci%C3%B3n-Electr%C3%B3nica?utm_source=panel&utm_medium=configuracion&utm_campaign=wordpress" target="_blank">¿Necesitás ayuda?</a>',
                'id'       => 'wc_settings_tab_woo_facturante_section_title'
            ),
            'user' => array(
                'name' => __( 'Email de usuario en Facturante', 'woo-facturante' ),
                'type' => 'text',
                'desc' => __( '¿No tenés cuenta? <a href="https://www.facturante.com/AsistenteRegistro?referrer=WooCommerce" target="_blank">Creala ahora</a>', 'woo-facturante' ),
                'id'   => 'wc_settings_tab_woo_facturante_user'
            ),
            'hash' => array(
                'name' => __( 'Contraseña de tu cuenta de Facturante', 'woo-facturante' ),
                'type' => 'password',
                'desc' => __( '', 'woo-facturante' ),
                'id'   => 'wc_settings_tab_woo_facturante_hash'
            ),
			'Id de empresa' => array(
                'name' => __( 'ID de Empresa', 'woo-facturante' ),
                'type' => 'text',
                'desc' => __( 'Para obtener este código deberás contactarte con nuestro equipo a <a href="mailto:contacto@facturante.com">contacto@facturante.com</a> indicando la CUIT de tu cuenta en Facturante', 'woo-facturante'),
                'id'   => 'wc_settings_tab_woo_facturante_organization_ID'
            ),
			
			'prefix' => array(
                'name' => __( 'Punto de venta', 'woo-facturante' ),
                'type' => 'text',
                'desc' => __( 'Prefijo que aparece en tus Comprobantes y que ingresaste en tu cuenta de Facturante. Ejemplo: 0005', 'woo-facturante' ),
                'id'   => 'wc_settings_tab_woo_facturante_prefix'
            ),
	
			
			'facturante_automatic' => array(
                'name' => __( 'Habilitar facturación automática', 'woocommerce-settings-tab-demo' ),
                'type' => 'checkbox',
                'desc' => __( '', 'woocommerce-settings-tab-demo' ),
                'id'   => 'facturante_automatic'
            ),
            'facturante_automatic_invoice_state' => array(
                'name' => __( 'Estado del pedido para ser facturado', 'woo-facturante' ),
                'type' => 'select',
                'desc' => __( 'Seleccioná en qué estado debe encontrarse el pedido para ser facturado automáticamente', 'woo-facturante' ),
                'id'   => 'facturante_automatic_invoice_state',
                'options' => $allStatus
            ),
	
			
			'facturante_automatic_nc' => array(
                'name' => __( 'Habilitar emisión automática de Notas de Crédito', 'woocommerce-settings-tab-demo' ),
                'type' => 'checkbox',
                'desc' => __( 'Al habilitar esta funcionalidad, cada vez que el pedido se encuentre en el estado que configures, se emitirá automáticamente una Nota de Crédito para anulación total', 'woocommerce-settings-tab-demo' ),
                'id'   => 'facturante_automatic_nc'
            ),
            'facturante_automatic_nc_invoice_state' => array(
                'name' => __( 'Estado del pedido para emitir Nota de Crédito', 'woo-facturante' ),
                'type' => 'select',
                'desc' => __( 'Seleccioná en qué estado debe encontrarse el pedido para que se emita la Nota de Crédito automáticamente', 'woo-facturante' ),
                'id'   => 'facturante_automatic_nc_invoice_state',
                'options' => $allStatus
            ),

            
            
            'facturante_b2b' => array(
                'name' => __( 'Habilitar facturación a tratamientos impositivos con CUIT', 'woocommerce-settings-tab-demo' ),
                'type' => 'checkbox',
                'desc' => __( 'Si sos Responsable Inscripto, habilitá esta funcionalidad para que Facturante emita una Factura A a los compradores que ingresen una CUIT en lugar de un DNI. Si no lo sos, habilitala si deseás que tus compradores puedan ingresar una CUIT en vez de un DNI', 'woo-facturante' ),
                'id'   => 'facturante_b2b'
            ),

            'sectionend' => array(
                 'type' => 'sectionend',
                 'id' => 'wc_settings_tab_woo_facturante_section_title'
            ),
			'section_contacto' => array(
                'name'     => __( '¿Necesitás asistencia? ', 'woo-facturante' ),
                'type'     => 'title',
                'desc' => 'Escribinos a <a href="mailto:soporte@facturante.com">soporte@facturante.com</a> indicando la CUIT de tu cuenta.',
                'id'       => 'wc_settings_tab_woo_facturante_section_contacto'
            ),
			'sectionend_contacto' => array(
                 'type' => 'sectionend',
                 'id' => 'wc_settings_tab_woo_facturante_section_contacto'
            ),
        );

        return apply_filters( 'wc_settings_tab_woo_facturante', $settings );
    }
	
}