function createModal() {
    const modal = document.createElement('div');
    modal.setAttribute('role', 'dialog');
    modal.setAttribute('tabindex', '-1');
    modal.className = "fac-modal";
    modal.id = "error";
    modal.innerHTML = `<div class="fac-modal-dialog" role="document">
            <div class="fac-modal-content">
                <div class="fac-modal-header">
                <h5 class="fac-modal-title">Detalles</h5>
                <button type="button" class="close" data-dismiss="fac-modal" aria-label="Close">
                    <span aria-hidden="true">&times;</span>
                </button>
                </div>
                <div class="fac-modal-body">
                <p class="text-center">Hubo un error al procesar la solicitud, intente nuevamente, si el problema persiste por favor comuniquese con el equipo de soporte a soporte@facturante.com
                </div>
                <div class="fac-modal-footer">
                </div>
            </div>
        </div>`;

    return modal;
}

(function($) {
    'use strict';
    $(function() {
        document.querySelector('body').appendChild(createModal());
    });
})(jQuery);


function generateInvoice($orderId, $element) {
    var id = jQuery($element).attr("id");
    jQuery('#' + id).attr("disabled", true);
    jQuery('#' + id).html("Generando...");
    var data = {
        action: 'woo_facturante_do_ajax_request',
        order: $orderId
    }
    jQuery.post(ajaxurl, data, function(data) {
        window.location.reload();
    });
}

function generateCreditNote($orderId, $element) {
    var id = jQuery($element).attr("id");
    jQuery('#' + id).attr("disabled", true);
    jQuery('#' + id).html("Generando...");
    var data = {
        action: 'woo_facturante_do_ajax_request_nc',
        order: $orderId
    }
    jQuery.post(ajaxurl, data, function(data) {
        window.location.reload();
    });
}

function refresh($orderId, $element, $nc) {
    if ($nc == undefined) $nc = false;
    var id = jQuery($element).attr("id");
    jQuery('#' + id).attr("disabled", true);
    jQuery('#' + id).html("Actualizando...");
    var data = {
        action: $nc ? 'woo_facturante_view_nc_ajax_request' : 'woo_facturante_view_ajax_request',
        order: $orderId
    }
    jQuery.post(ajaxurl, data, function(data) {
        window.location.reload();
    });
}

function addModalContent(message) {
    document.querySelector('#error .fac-modal-body p').innerHTML = message;
}


function disable(element) {
    element.attr('disabled','disabled');
}

function enable(element) {
    element.removeAttr('disabled');
}

jQuery(document).ready(function() {
    try{

        disable(jQuery('#facturante_automatic_invoice_state'));
        disable(jQuery('#facturante_automatic_nc_invoice_state'));
    
        if(document.getElementById("facturante_automatic").checked)
            enable(jQuery('#facturante_automatic_invoice_state'));
        if(document.getElementById("facturante_automatic_nc").checked)
            enable(jQuery('#facturante_automatic_nc_invoice_state'));
    
        jQuery('#facturante_automatic').change(function(){
            disable(jQuery('#facturante_automatic_invoice_state'));
            if(document.getElementById("facturante_automatic").checked)
                enable(jQuery('#facturante_automatic_invoice_state'));
        });
    
        jQuery('#facturante_automatic_nc').change(function(){
            disable(jQuery('#facturante_automatic_nc_invoice_state'));
            if(document.getElementById("facturante_automatic_nc").checked)
                enable(jQuery('#facturante_automatic_nc_invoice_state'));
        });
        
        jQuery('#facturante_automatic_nc_invoice_state').change(function(){
            compareState();
        });
        jQuery('#facturante_automatic_invoice_state').change(function(){
            compareState();
        });
        
        jQuery('button[type=submit]').click(function(evt){
            if (equalState()){
                evt.stopPropagation();
                evt.preventDefault();
                compareState();
            }
        });
    } catch(error) {

    }
});

function compareState(){
    enable(jQuery('button[type=submit]'));
    if(equalState()){
        disable(jQuery('button[type=submit]'));
        addModalContent('No puedes poner el mismo estado para las facturas y las notesa de credito');
        jQuery('#error')['fac-modal']('show');
    }
}   

function equalState(){
    return (document.getElementById("facturante_automatic").checked && document.getElementById("facturante_automatic_nc").checked) && jQuery('#facturante_automatic_invoice_state').val() == jQuery('#facturante_automatic_nc_invoice_state').val();
}