<?php

require_once dirname(__FILE__).'/MapperInterface.php';
require_once dirname(__DIR__, 2).'/domain/DTO/ReceiptStates.php';
require_once dirname(__DIR__).'/WoocommerceStates.php';

class WoocommerceFacturanteStatesMapper implements MapperInterface {
    
    private $facturanteStatess;
    private $woocommerceStates;

    public function __construct() {
        $this->facturanteStatess = new ReceiptStates();
        $this->woocommerceStates = new WoocommerceStates();
    }


    public function map($toMap){
         switch($toMap) {
            case ReceiptStates::PROCESADO: 
            case ReceiptStates::ENVIANDO:
            case ReceiptStates::SIN_ENVIO:
                return WoocommerceStates::OK;
            case  ReceiptStates::ERROR_EN_AFIP: 
                return WoocommerceStates::ERROR_AFIP;
            case ReceiptStates::ERROR_EN_COMPROBANTE: 
                return WoocommerceStates::ERROR_COMPROBANTE;
            case ReceiptStates::OBTENIENDO_CAE:
            case ReceiptStates::SIN_SERVICIO_AFIP:
            case ReceiptStates::ESPERANDO_CAE:
            case ReceiptStates::TIMEOUT_AFIP:
            case ReceiptStates::ESPERANDO_RESPUESTA_AFIP:
                return WoocommerceStates::PROCESANDO ;
            default: 
                throw new Exception('Invalid facturante state');  
        };
    }
}

?>