<?php
class ReceiptStates{

    /*
    -      1: OBTENIENDO CAE: Se está esperando la confirmación de Afip. (Estado temporal)
    -      2: ENVIANDO: El comprobante ya obtuvo el CAE, se confecciono el PDF y está siendo enviado al cliente. (Estado Final)(Estado Temporal)
    -      3: SIN ENVIO: El comprobante ya obtuvo el CAE, se confecciono el PDF y NO se pudo enviar al cliente. (Estado Final)(Estado Temporal)
    -      4: PROCESADO: El comprobante ya obtuvo el CAE, se confecciono el PDF, se realizó el envío al cliente con éxito y está esperando que el cliente lo abra. (Estado Final)
    -      5: SIN SERVICIO AFIP: La Webservices de Afip se encuentra sin servicio. (Estado Temporal)
    -      6: ERROR EN COMPROBANTE: indica que el comprobante NO fue validado por AFIP. De modo que deberá evaluar el error para rehacer el comprobante salvando el mismo. (Estado Final)
    -      7: ERROR EN AFIP: Error en la respuesta de Afip – (Acción: nueva petición del comprobante, sin modificación de la solicitud) . (Estado Final)
    -      8: ESPERANDO CAE: indica que el comprobante está esperando para ser validado en AFIP. (Estado temporal)
    -      9: TIMEOUT AFIP: AFIP no respondió a tiempo la solicitud y se está resolviendo la situación. (Estado temporal)
    -      10: ESPERANDO RESPUESTA AFIP: indica que ya se solicitó la validación al WS de AFIP y se está esperando la respuesta. (Estado temporal)
    */
    const OBTENIENDO_CAE=1;
    const ENVIANDO=2;
    const SIN_ENVIO=3;
    const PROCESADO=4;
    const SIN_SERVICIO_AFIP=5;
    const ERROR_EN_COMPROBANTE=6;
    const ERROR_EN_AFIP=7;
    const ESPERANDO_CAE=8;
    const TIMEOUT_AFIP=9;
    const ESPERANDO_RESPUESTA_AFIP=10;

    public static function getErrorCAEStates(){
        return [ReceiptStates::ERROR_EN_AFIP,ReceiptStates::ERROR_EN_COMPROBANTE];
    }
}