<?php

require_once dirname(__FILE__).'/ResponseModel.php';
require_once dirname(__DIR__).'/DTO/ResponseType.php';
require_once dirname(__DIR__).'/DTO/ReceiptStates.php';

class ViewInvoiceResponseModel extends ResponseModel implements ResponseInterface {

    private $comprobante;

    public function __construct($response){     
            $this->comprobante = $response->DetalleComprobanteResult->Comprobante;
            if($response->DetalleComprobanteResult->Comprobante->CAE && !in_array($this->getEstadoComprobante(),ReceiptStates::getErrorCAEStates())){    
                $this->data = ['URLPDF'=>$this->getURL(),'EstadoComprobante'=>$this->getEstadoComprobante()];
            }else{
                $this->error=true;
                $this->data =  ['MensajeAfip'=>$response->DetalleComprobanteResult->Comprobante->MensajeAFIP,'EstadoComprobante'=>$this->getEstadoComprobante()];
            }
    }

    public function getResponse($responseType){
        switch($responseType){
            case ResponseType::ARRAY_TYPE:
                return $this->getArrayResponse();
            case ResponseType::JSON_TYPE: 
                return $this->getJsonResponse();
        }
    }

    public function getEstadoComprobante(){
        return $this->comprobante->EstadoComprobante;
    }

    public function getURL(){
        return $this->comprobante->URLPDF;
    }
    
    public function getJsonResponse(){
        return json_encode($this);
    }

}